<?php
/***********************************************************************

  Copyright (C) 2002-2007  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


if (isset($_GET['action']))
	define('PUN_QUIET_VISIT', 1);

define('PUN_ROOT', './');
require PUN_ROOT.'include/common.php';

// Load the login.php language file
require PUN_ROOT.'lang/'.$pun_user['language'].'/login.php';


$action = isset($_GET['action']) ? $_GET['action'] : null;


// Login
if (isset($_POST['form_sent']) && $action == 'in')
{
	$form_username = trim($_POST['req_username']);
	$form_password = trim($_POST['req_password']);

	// Get user info matching login attempt
	$query = array(
		'SELECT'	=> 'u.id, u.group_id, u.password, u.save_pass, u.salt',
		'FROM'		=> 'users AS u'
	);

	if ($db_type == 'mysql' || $db_type == 'mysqli')
		$query['WHERE'] = 'username=\''.$db->escape($form_username).'\'';
	else
		$query['WHERE'] = 'LOWER(username)=LOWER(\''.$db->escape($form_username).'\')';

	($hook = get_hook('li_qr_get_login_data')) ? eval($hook) : null;
	$result = $db->query_build($query) or error(__FILE__, __LINE__);
	list($user_id, $group_id, $db_password_hash, $save_pass, $salt) = $db->fetch_row($result);

	$authorized = false;
	if (!empty($db_password_hash))
	{
		$sha1_in_db = (strlen($db_password_hash) == 40) ? true : false;
		$form_password_hash = sha1($salt.sha1($form_password));

		if ($sha1_in_db && $db_password_hash == $form_password_hash)
			$authorized = true;
		else if ((!$sha1_in_db && $db_password_hash == md5($form_password)) || ($sha1_in_db && $db_password_hash == sha1($form_password)))
		{
			$authorized = true;

			$salt = random_key(12);
			$form_password_hash = sha1($salt.sha1($form_password));

			// There's an old MD5 hash or an unsalted SHA1 hash in the database, so we replace it
			// with a randomly generated salt and a new, salted SHA1 hash
			$query = array(
				'UPDATE'	=> 'users',
				'SET'		=> 'password=\''.$form_password_hash.'\', salt=\''.$db->escape($salt).'\'',
				'WHERE'		=> 'id='.$user_id
			);

			($hook = get_hook('li_qr_update_user_hash')) ? eval($hook) : null;
			$db->query_build($query) or error(__FILE__, __LINE__);
		}
	}

	if (!$authorized)
		message($lang_login['Wrong user/pass'].' <a href="'.pun_link($pun_url['request_password']).'">'.$lang_login['Forgotten password'].'</a>');

	// Update the status if this is the first time the user logged in
	if ($group_id == PUN_UNVERIFIED)
	{
		$query = array(
			'UPDATE'	=> 'users',
			'SET'		=> 'group_id='.$pun_config['o_default_user_group'],
			'WHERE'		=> 'id='.$user_id
		);

		($hook = get_hook('li_qr_update_user_group')) ? eval($hook) : null;
		$db->query_build($query) or error(__FILE__, __LINE__);
	}

	// Remove this user's guest entry from the online list
	$query = array(
		'DELETE'	=> 'online',
		'WHERE'		=> 'ident=\''.$db->escape(get_remote_address()).'\''
	);

	($hook = get_hook('li_qr_delete_online_user')) ? eval($hook) : null;
	$db->query_build($query) or error(__FILE__, __LINE__);

	$expire = ($save_pass == '1') ? time() + 31536000 : 0;
	pun_setcookie($user_id, $form_password_hash, $expire);

	redirect(htmlspecialchars($_POST['redirect_url']).((substr_count($_POST['redirect_url'],'?') == 1) ? '&' : '?').'login=1', $lang_login['Login redirect']);
}


// Logout
else if ($action == 'out')
{
	if ($pun_user['is_guest'] || !isset($_GET['id']) || $_GET['id'] != $pun_user['id'])
	{
		header('Location: '.pun_link($pun_url['index']));
		exit;
	}

	// Remove user from "users online" list.
	$query = array(
		'DELETE'	=> 'online',
		'WHERE'		=> 'user_id='.$pun_user['id']
	);

	($hook = get_hook('li_qr_delete_online_user2')) ? eval($hook) : null;
	$db->query_build($query) or error(__FILE__, __LINE__);

	// Update last_visit (make sure there's something to update it with)
	if (isset($pun_user['logged']))
	{
		$query = array(
			'UPDATE'	=> 'users',
			'SET'		=> 'last_visit='.$pun_user['logged'],
			'WHERE'		=> 'id='.$pun_user['id']
		);

		($hook = get_hook('li_qr_update_last_visit')) ? eval($hook) : null;
		$db->query_build($query) or error(__FILE__, __LINE__);
	}

	pun_setcookie(1, random_key(8, true), time() + 31536000);

	// Reset tracked topics
	set_tracked_topics(null);

	redirect(pun_link($pun_url['index']), $lang_login['Logout redirect']);
}


// New password
else if ($action == 'forget' || $action == 'forget_2')
{
	if (!$pun_user['is_guest'])
		header('Location: '.pun_link($pun_url['index']));

	if (isset($_POST['form_sent']))
	{
		require PUN_ROOT.'include/email.php';

		// Validate the email-address
		$email = strtolower(trim($_POST['req_email']));
		if (!is_valid_email($email))
			message($lang_common['Invalid e-mail']);

		// Fetch user matching $email
		$query = array(
			'SELECT'	=> 'u.id, u.username, u.salt',
			'FROM'		=> 'users AS u',
			'WHERE'		=> 'u.email=\''.$db->escape($email).'\''
		);

		($hook = get_hook('li_qr_get_user_data')) ? eval($hook) : null;
		$result = $db->query_build($query) or error(__FILE__, __LINE__);
		if ($db->num_rows($result))
		{
			// Load the "activate password" template
			$mail_tpl = trim(file_get_contents(PUN_ROOT.'lang/'.$pun_user['language'].'/mail_templates/activate_password.tpl'));

			// The first row contains the subject
			$first_crlf = strpos($mail_tpl, "\n");
			$mail_subject = trim(substr($mail_tpl, 8, $first_crlf-8));
			$mail_message = trim(substr($mail_tpl, $first_crlf));

			// Do the generic replacements first (they apply to all e-mails sent out here)
			$mail_message = str_replace('<base_url>', $base_url.'/', $mail_message);
			$mail_message = str_replace('<board_mailer>', sprintf($lang_common['Forum mailer'], $pun_config['o_board_title']), $mail_message);

			// Loop through users we found
			while ($cur_hit = $db->fetch_assoc($result))
			{
				// Generate a new password activation key
				$new_password_key = random_key(8, true);

				$query = array(
					'UPDATE'	=> 'users',
					'SET'		=> 'activate_key=\''.$new_password_key.'\'',
					'WHERE'		=> 'id='.$cur_hit['id']
				);

				($hook = get_hook('li_qr_set_activate_key')) ? eval($hook) : null;
				$db->query_build($query) or error(__FILE__, __LINE__);

				// Do the user specific replacements to the template
				$cur_mail_message = str_replace('<username>', $cur_hit['username'], $mail_message);
				$cur_mail_message = str_replace('<activation_url>', str_replace('&amp;', '&', pun_link($pun_url['change_password_key'], array($cur_hit['id'], $new_password_key))), $cur_mail_message);

				pun_mail($email, $mail_subject, $cur_mail_message);
			}

			message(sprintf($lang_login['Forget mail'], '<a href="mailto:'.$pun_config['o_admin_email'].'">'.$pun_config['o_admin_email'].'</a>'));
		}
		else
			message(sprintf($lang_login['No e-mail match'], htmlspecialchars($email)));
	}


	// Setup breadcrumbs
	$pun_page['crumbs'] = array(
		array($pun_config['o_board_title'], pun_link($pun_url['index'])),
		$lang_login['New password request']
	);

	define ('PUN_PAGE', 'dialogue');
	require PUN_ROOT.'header.php';

	$set_count = 0;
	$fld_count = 0;
	$req_field = '<em class="req-text">&#160;<span>'.$lang_common['Required'].'</span></em>';

	// Setup form help/instructions
	$lostpass_info[] = '<li id="req-msg" class="warn req-warn"><span>'.sprintf($lang_common['Required warn'], $req_field).'</span></li>';
	$lostpass_info[] = '<li class="warn">'.$lang_login['Request pass info'].'</li>';
	$lostpass_info[] = '<li>'.$lang_login['New password info'].'</li>';

?>
<div id="pun-main" class="main">

	<h1><span><?php echo end($pun_page['crumbs']) ?></span></h1>

	<div class="main-form">
		<h2><span><?php echo $lang_login['New password head'] ?></span></h2>
		<form id="afocus" class="fm-form" method="post" accept-charset="utf-8" action="<?php echo $base_url ?>/login.php?action=forget_2">
			<div class="hidden">
				<input type="hidden" name="form_sent" value="1" />
			</div>
			<div class="form-info">
				<ul>
					<?php echo implode("\n\t\t\t\t\t", $lostpass_info)."\n" ?>
				</ul>
			</div>
			<fieldset class="fm-set set<?php echo ++$set_count ?>">
				<legend class="fm-legend"><strong></strong></legend>
				<div class="text required">
					<label for="fld<?php echo ++$fld_count ?>">
						<span class="fm-label"><?php echo $lang_login['E-mail address'] ?> <em class="req-text"><?php echo $lang_common['Required mark'].' <span>'.$lang_common['Required'].'</span>' ?></em></span><br />
						<span class="fm-input"><input id="fs1f1" type="text" name="req_email" size="35" maxlength="80" /></span>
					</label>
				</div>
			</fieldset>
			<div class="form-buttons">
				<span class="submit"><input type="submit" class="button" name="request_pass" value="<?php echo $lang_common['Submit'] ?>" /></span>
			</div>
		</form>
	</div>

</div>
<?php

	require PUN_ROOT.'footer.php';
}


if (!$pun_user['is_guest'])
	header('Location: '.pun_link($pun_url['index']));

// Try to determine if the data in HTTP_REFERER is valid (if not, we redirect to index.php after login)
$redirect_url = (isset($_SERVER['HTTP_REFERER']) && preg_match('#^'.preg_quote($base_url).'/(.*?)\.php#i', $_SERVER['HTTP_REFERER'])) ? htmlspecialchars($_SERVER['HTTP_REFERER']) : pun_link($pun_url['index']);


// Setup breadcrumbs
$pun_page['crumbs'] = array(
	array($pun_config['o_board_title'], pun_link($pun_url['index'])),
	$lang_common['Login']
);

define('PUN_PAGE', 'login');
require PUN_ROOT.'header.php';

$set_count = 0;
$fld_count = 0;
$req_field = '<em class="req-text">&#160;<span>'.$lang_common['Required'].'</span></em>';

// Setup form help/instructions/information
$login_info[] = '<li id="req-msg" class="warn req-warn"><span>'.sprintf($lang_common['Required warn'], $req_field).'</span></li>';
$login_info[] = '<li>'.sprintf($lang_login['Must be registered'], '<a href="'.pun_link($pun_url['register']).'">'.$lang_login['Register now'].'</a>').'</li>';
$login_info[] = '<li>'.sprintf($lang_login['Forgotten password'], '<a href="'.pun_link($pun_url['request_password']).'">'.$lang_login['Request pass'].'</a>').'</li>';

?>
<div id="pun-main" class="main">

	<h1><span><?php echo end($pun_page['crumbs']) ?></span></h1>

	<div class="main-form">
		<h2><span><?php printf($lang_login['Login info'], htmlspecialchars($pun_config['o_board_title'])) ?></span></h2>
		<form id="afocus" class="fm-form" method="post" accept-charset="utf-8" action="<?php echo $base_url ?>/login.php?action=in">
			<div class="hidden">
				<input type="hidden" name="form_sent" value="1" />
				<input type="hidden" name="redirect_url" value="<?php echo $redirect_url ?>" />
			</div>
			<div class="form-info">
				<ul>
					<?php echo implode("\n\t\t\t\t\t", $login_info)."\n" ?>
				</ul>
			</div>
			<fieldset class="fm-set set<?php echo ++$set_count ?>">
				<legend class="fm-legend"><strong><?php echo $lang_login['Login information'] ?></strong></legend>
				<div class="text required">
					<label for="fld<?php echo ++$fld_count ?>">
						<span class="fm-label"><?php echo $lang_login['Username'] ?></span><?php echo $req_field ?><br />
						<span class="fm-input"><input type="text" id="fld<?php echo $fld_count ?>" name="req_username" size="30" maxlength="25" /></span><br />
					</label>
				</div>
				<div class="text required">
					<label for="fld<?php echo ++$fld_count ?>">
						<span class="fm-label"><?php echo $lang_login['Password'] ?></span><?php echo $req_field ?><br />
						<span class="fm-input"><input type="password" id="fld<?php echo $fld_count ?>" name="req_password" size="30" /></span><br />
					</label>
				</div>
			</fieldset>
			<div class="form-buttons">
				<span class="submit"><input type="submit" class="button" name="login" value="<?php echo $lang_common['Login'] ?>" /></span>
			</div>
		</form>
	</div>

</div>
<?php

require PUN_ROOT.'footer.php';